@echo off
rem (C) SSoft 2024 z-print@bk.ru
rem размещает все страницы из первого файла на подложки (шаблоны) из второго
rem и сохраняет в третий или в файл по умолчанию
rem то есть печать переменных данных на переменныхх шаблонах 
rem из побочек - в выходном файле может быть больше страниц, чем в исходном,
rem если их количество не кратно количеству страниц в файле с шаблонами
rem Warning'и можно игнорировать, но проверять все равно нужно

IF NOT EXIST "%1" goto wrongfile
IF NOT EXIST "%2" goto wrongfile


set SRC=%1
set BACKS=%2

set ALLBACKS=%temp%\allbacks.pdf
rem set default output name
set OUT=%SRC:~0,-4%_with_backs.pdf
rem or set ouput name if it present in command line
IF NOT [%3]==[] set out=%3

rem Определим количество страниц в файле с переменными данными
rem тупо взял из сети, там какая-то заморочка
setlocal ENABLEDELAYEDEXPANSION
FOR /F "usebackq delims=" %%a IN (`cpdf -info %SRC% ^| find "Pages:"`) DO (set result=%%a)
rem отрежем слово pages: и используем остаток как число страниц (именно как число /a)
set /a varpages = %result:~7%

rem Определим количество страниц в файле с фонами
FOR /F "usebackq delims=" %%a IN (`cpdf -info %BACKS% ^| find "Pages:"`) DO (set result=%%a)
rem отрежем слово pages: и используем остаток как число страниц (именно как число /a)
set /a backpages = %result:~7%
echo Processing. Please wait
cpdf "%BACKS%" -o "%ALLBACKS%"
rem наделаем нужное количество подложек
setlocal enableextensions enabledelayedexpansion

for /L %%i in (1,%backpages%,%varpages%) do set LIST=!LIST!,1-%backpages%
set LIST=%LIST:~1%

cpdf "%BACKS%" %LIST% -o "%ALLBACKS%" AND -combine-pages "%SRC%" "%ALLBACKS%" -producer "SSoft mvardata" -o "%OUT%"

del "%ALLBACKS%"

echo "%OUT%" Done!
echo Check It. File may be longer then source file if a non-multiple number of backs` used

exit /b 0

:wrongfile

echo (C) SSoft 2024 z-print@bk.ru
echo places variable data pages from variable_pages.pdf over backpages of templates.pdf again and again  
echo Usage: %0 variable_pages.pdf templates.pdf [outputfile.pdf]

IF NOT EXIST "%1" echo no variable data file %1
IF NOT EXIST "%2" echo no templates file %2
exit /b -1